/* 
 * Please read the COPYRIGHT notice included at the top level
 */

#ifndef	_AUGMENT_H
#define	_AUGMENT_H

/* Compute the offset of `pevent' field  in thread_t  */
#define	THREAD_EVENT_OFFSET (offsetof(thread_t,pevent))

/* offset of `tmp1' field */
#define	THREAD_TMP1_OFFSET (offsetof(thread_t,tmp1))

/* offset of `tmp2' field */
#define	THREAD_TMP2_OFFSET (offsetof(thread_t,tmp2))

/* offset of the `time' field */
#define	THREAD_TIME_OFFSET (offsetof(thread_t,time))

/* compute the offset of the `type' field in event_t */
#define	EVENT_TYPE_OFFSET (offsetof(event_t,type))

/* compute the offset of the `vaddr' field */
#define	EVENT_VADDR_OFFSET (offsetof(event_t,vaddr))

/* compute the offset of the `size' field */
#define	EVENT_SIZE_OFFSET (offsetof(event_t,size))

/* compute the offseet of the `value' field */
#define	EVENT_VALUE_OFFSET (offsetof(event_t,value))

#define	NUM_REGS_PUSHED	3

/* macro to get the `pevent' field into the REG */
#define	GET_PEVENT(REG)\
      augment("\tmovl pcur_thread,%%"#REG"\n");	\
      augment("\tmovl %d(%%"#REG"),%%"#REG"\n",THREAD_EVENT_OFFSET)

/* macro to get a pointer to the  current_thread in the REG */
#define	GET_PTHREAD(REG)\
      augment("\tmovl pcur_thread,%%"#REG"\n");

/* macro to save the vaddr into a temporary location */
#define	AUGMENT_SAVE_VADDR1 \
      augment("\tmovl %%eax,__tmp_vaddr\n")

void augment_instruction (instr_t *instr);
void augment_push_regs ();
void augment_put_stuff (instr_t *instr, ref_t *ref);
void augment_ctxsw_intel (instr_t *instr);
void augment_pop_regs ();
void check_references (instr_t *instr);
void augment_put_more_stuff (instr_t *instr, ref_t *ref);
void augment_move_data (instr_t *instr, ref_t *ref);
void augment_restore_memory (instr_t *instr);
void augment_update_clock ();
void augment_safe_update_clock ();
bool_t data_movement_safe (instr_t *instr);

#endif /* _AUGMENT_H */
