/* 
 * Please read the COPYRIGHT notice included at the top level
 */
#ifndef	_KEYWORD_T_H
#define	_KEYWORD_T_H

/*
 * keyword_t.h,v 1.1.1.1 1996/07/18 22:39:58 arsharma Exp
 * keyword table - now reduced to a register table
 */

#include "y.tab.h"

static struct keyword_table {
    char *keyword_name;
    int keyword_representation;
} keyword_table[] =

{
    "%ah", AH,
	"%al", AL,
	"%ax", AX,
	"%bh", BH,
	"%bl", BL,
	"%bp", BP,
	"%bx", BX,
	"%ch", CH,
	"%cl", CL,
	"%cr0", CR0,
	"%cr2", CR2,
	"%cr3", CR3,
	"%cs", CS,
	"%cx", CX,
	"%db0", DB0,
	"%db1", DB1,
	"%db2", DB2,
	"%db3", DB3,
	"%db6", DB6,
	"%db7", DB7,
	"%dh", DH,
	"%di", DI,
	"%dl", DL,
	"%ds", DS,
	"%dx", DX,
	"%eax", EAX,
	"%ebp", EBP,
	"%ebx", EBX,
	"%ecx", ECX,
	"%edi", EDI,
	"%edx", EDX,
	"%es", ES,
	"%esi", ESI,
	"%esp", ESP,
	"%fs", FS,
	"%gs", GS,
	"%si", SI,
	"%sp", SP,
	"%ss", SS,
	"%st", ST0,
	"%st(0)", ST0,
	"%st(1)", ST1,
	"%st(2)", ST2,
	"%st(3)", ST3,
	"%st(4)", ST4,
	"%st(5)", ST5,
	"%st(6)", ST6,
	"%st(7)", ST7,
	"%tr6", TR6,
	"%tr7", TR7,
	"lock", LOCK,
	"rep", REP,
	"repe", REPE,
	"repne", REPNE,
	"repnz", REPNZ,
	"repz", REPZ,

};

#endif /* _KEYWORD_T_H */
