#ifndef _MNEMONCS_DEF_H 
#define _MNEMONICS_DEF_H

#define AAA 1
#define AAD 2
#define AAM 3
#define AAS 4
#define ADC 5
#define ADCB 6
#define ADCL 7
#define ADCW 8
#define ADD 9
#define ADDB 10
#define ADDL 11
#define ADDW 12
#define AND 13
#define ANDB 14
#define ANDL 15
#define ANDW 16
#define ARPL 17
#define BOUND 18
#define BOUNDL 19
#define BOUNDW 20
#define BSF 21
#define BSFL 22
#define BSFW 23
#define BSR 24
#define BSRL 25
#define BSRW 26
#define BSWAP 27
#define BT 28
#define BTC 29
#define BTCL 30
#define BTCW 31
#define BTL 32
#define BTR 33
#define BTRL 34
#define BTRW 35
#define BTS 36
#define BTSL 37
#define BTSW 38
#define BTW 39
#define CALL 40
#define CBTW 41
#define CBW 42
#define CDQ 43
#define CLC 44
#define CLD 45
#define CLI 46
#define CLTD 47
#define CLTS 48
#define CMC 49
#define CMP 50
#define CMPB 51
#define CMPL 52
#define CMPS 53
#define CMPSB 54
#define CMPSL 55
#define CMPSW 56
#define CMPW 57
#define CMPXCHG 58
#define CMPXCHG8B 59
#define CMPXCHGB 60
#define CMPXCHGL 61
#define CMPXCHGW 62
#define CWD 63
#define CWDE 64
#define CWTD 65
#define CWTL 66
#define DAA 67
#define DAS 68
#define DEC 69
#define DECB 70
#define DECL 71
#define DECW 72
#define DIV 73
#define DIVB 74
#define DIVL 75
#define DIVW 76
#define ENTER 77
#define F2XM1 78
#define FABS 79
#define FADD 80
#define FADDL 81
#define FADDP 82
#define FADDS 83
#define FBLD 84
#define FBSTP 85
#define FCHS 86
#define FCLEX 87
#define FCOM 88
#define FCOML 89
#define FCOMP 90
#define FCOMPL 91
#define FCOMPP 92
#define FCOMPS 93
#define FCOMS 94
#define FCOS 95
#define FDECSTP 96
#define FDIV 97
#define FDIVL 98
#define FDIVP 99
#define FDIVR 100
#define FDIVRL 101
#define FDIVRP 102
#define FDIVRS 103
#define FDIVRW 104
#define FDIVS 105
#define FDIVW 106
#define FFREE 107
#define FIADD 108
#define FIADDL 109
#define FIADDS 110
#define FICOM 111
#define FICOML 112
#define FICOMP 113
#define FICOMPL 114
#define FICOMPS 115
#define FICOMS 116
#define FIDIV 117
#define FIDIVL 118
#define FIDIVR 119
#define FIDIVRL 120
#define FIDIVRS 121
#define FIDIVS 122
#define FILD 123
#define FILDL 124
#define FILDLL 125
#define FILDW 126
#define FIMUL 127
#define FIMULL 128
#define FIMULS 129
#define FINCSTP 130
#define FINIT 131
#define FIST 132
#define FISTL 133
#define FISTP 134
#define FISTPL 135
#define FISTPLL 136
#define FISTPS 137
#define FISTS 138
#define FISUB 139
#define FISUBL 140
#define FISUBR 141
#define FISUBRL 142
#define FISUBRS 143
#define FISUBS 144
#define FLD 145
#define FLD1 146
#define FLDCW 147
#define FLDENV 148
#define FLDL 149
#define FLDL2E 150
#define FLDL2T 151
#define FLDLG2 152
#define FLDLN2 153
#define FLDPI 154
#define FLDS 155
#define FLDT 156
#define FLDZ 157
#define FMUL 158
#define FMULL 159
#define FMULP 160
#define FMULS 161
#define FMULW 162
#define FNCLEX 163
#define FNINIT 164
#define FNOP 165
#define FNSAVE 166
#define FNSAVED 167
#define FNSAVEW 168
#define FNSTCW 169
#define FNSTENV 170
#define FNSTENVD 171
#define FNSTENVW 172
#define FNSTSW 173
#define FPATAN 174
#define FPREM 175
#define FPREM1 176
#define FPTAN 177
#define FRNDINT 178
#define FRSTOR 179
#define FSAVE 180
#define FSCALE 181
#define FSETPM 182
#define FSIN 183
#define FSINCOS 184
#define FSQRT 185
#define FST 186
#define FSTCW 187
#define FSTENV 188
#define FSTL 189
#define FSTP 190
#define FSTPL 191
#define FSTPS 192
#define FSTPT 193
#define FSTPW 194
#define FSTS 195
#define FSTSW 196
#define FSTW 197
#define FSUB 198
#define FSUBL 199
#define FSUBP 200
#define FSUBR 201
#define FSUBRL 202
#define FSUBRP 203
#define FSUBRS 204
#define FSUBRW 205
#define FSUBS 206
#define FTST 207
#define FUCOM 208
#define FUCOMP 209
#define FUCOMPP 210
#define FWAIT 211
#define FXAM 212
#define FXCH 213
#define FXTRACT 214
#define FYL2X 215
#define FYL2XP1 216
#define HLT 217
#define IDIV 218
#define IDIVB 219
#define IDIVL 220
#define IDIVW 221
#define IMUL 222
#define IMULB 223
#define IMULL 224
#define IMULW 225
#define IN 226
#define INB 227
#define INC 228
#define INCB 229
#define INCL 230
#define INCW 231
#define INL 232
#define INS 233
#define INSB 234
#define INSD 235
#define INSL 236
#define INSW 237
#define INT 238
#define INT3 239
#define INTO 240
#define INVD 241
#define INVLPG 242
#define INW 243
#define IRET 244
#define IRETF 245
#define JA 246
#define JAE 247
#define JB 248
#define JBE 249
#define JC 250
#define JCXZ 251
#define JE 252
#define JECXZ 253
#define JG 254
#define JGE 255
#define JL 256
#define JLE 257
#define JMP 258
#define JNA 259
#define JNAE 260
#define JNB 261
#define JNBE 262
#define JNC 263
#define JNE 264
#define JNG 265
#define JNGE 266
#define JNL 267
#define JNLE 268
#define JNO 269
#define JNP 270
#define JNS 271
#define JNZ 272
#define JO 273
#define JP 274
#define JPE 275
#define JPO 276
#define JS 277
#define JZ 278
#define LAHF 279
#define LAR 280
#define LARL 281
#define LARW 282
#define LCALL 283
#define LDS 284
#define LDSL 285
#define LDSW 286
#define LEA 287
#define LEAL 288
#define LEAVE 289
#define LEAW 290
#define LES 291
#define LESL 292
#define LESW 293
#define LFS 294
#define LFSL 295
#define LFSW 296
#define LGDT 297
#define LGS 298
#define LGSL 299
#define LGSW 300
#define LIDT 301
#define LIRET 302
#define LJMP 303
#define LLDT 304
#define LMSW 305
#define LODS 306
#define LODSB 307
#define LODSD 308
#define LODSL 309
#define LODSW 310
#define LOOP 311
#define LOOPE 312
#define LOOPNE 313
#define LOOPNZ 314
#define LOOPZ 315
#define LRET 316
#define LSL 317
#define LSLL 318
#define LSLW 319
#define LSS 320
#define LSSL 321
#define LSSW 322
#define LTR 323
#define MOV 324
#define MOVB 325
#define MOVL 326
#define MOVS 327
#define MOVSB 328
#define MOVSBL 329
#define MOVSBW 330
#define MOVSBWL 331
#define MOVSL 332
#define MOVSW 333
#define MOVSWL 334
#define MOVW 335
#define MOVZB 336
#define MOVZBL 337
#define MOVZBW 338
#define MOVZWL 339
#define MUL 340
#define MULB 341
#define MULL 342
#define MULW 343
#define NEG 344
#define NEGB 345
#define NEGL 346
#define NEGW 347
#define NOP 348
#define NOT 349
#define NOTB 350
#define NOTL 351
#define NOTW 352
#define OR 353
#define ORB 354
#define ORL 355
#define ORW 356
#define OUT 357
#define OUTB 358
#define OUTL 359
#define OUTS 360
#define OUTSB 361
#define OUTSD 362
#define OUTSL 363
#define OUTSW 364
#define OUTW 365
#define POP 366
#define POPA 367
#define POPAL 368
#define POPAW 369
#define POPF 370
#define POPFL 371
#define POPFW 372
#define POPL 373
#define POPW 374
#define PUSH 375
#define PUSHA 376
#define PUSHAL 377
#define PUSHAW 378
#define PUSHF 379
#define PUSHFL 380
#define PUSHFW 381
#define PUSHL 382
#define PUSHW 383
#define RCL 384
#define RCLB 385
#define RCLL 386
#define RCLW 387
#define RCR 388
#define RCRB 389
#define RCRL 390
#define RCRW 391
#define RET 392
#define ROL 393
#define ROLB 394
#define ROLL 395
#define ROLW 396
#define ROR 397
#define RORB 398
#define RORL 399
#define RORW 400
#define SAHF 401
#define SAL 402
#define SALB 403
#define SALL 404
#define SALW 405
#define SAR 406
#define SARB 407
#define SARL 408
#define SARW 409
#define SBB 410
#define SBBB 411
#define SBBL 412
#define SBBW 413
#define SCAS 414
#define SCASB 415
#define SCASL 416
#define SCASW 417
#define SETA 418
#define SETAE 419
#define SETB 420
#define SETBE 421
#define SETC 422
#define SETE 423
#define SETG 424
#define SETGE 425
#define SETL 426
#define SETLE 427
#define SETNA 428
#define SETNAE 429
#define SETNB 430
#define SETNBE 431
#define SETNC 432
#define SETNE 433
#define SETNG 434
#define SETNGE 435
#define SETNL 436
#define SETNLE 437
#define SETNO 438
#define SETNP 439
#define SETNS 440
#define SETNZ 441
#define SETO 442
#define SETP 443
#define SETPE 444
#define SETPO 445
#define SETS 446
#define SETZ 447
#define SGDT 448
#define SHL 449
#define SHLB 450
#define SHLD 451
#define SHLDL 452
#define SHLDW 453
#define SHLL 454
#define SHLW 455
#define SHR 456
#define SHRB 457
#define SHRD 458
#define SHRL 459
#define SHRW 460
#define SIDT 461
#define SLDT 462
#define SMOVB 463
#define SMOVL 464
#define SMOVW 465
#define SMSW 466
#define STC 467
#define STD 468
#define STI 469
#define STOS 470
#define STOSB 471
#define STOSL 472
#define STOSW 473
#define STR 474
#define SUB 475
#define SUBB 476
#define SUBL 477
#define SUBW 478
#define TEST 479
#define TESTB 480
#define TESTL 481
#define TESTW 482
#define VERR 483
#define VERW 484
#define WAIT 485
#define WBINVD 486
#define XADD 487
#define XADDB 488
#define XADDL 489
#define XADDW 490
#define XCHG 491
#define XCHGB 492
#define XCHGL 493
#define XCHGW 494
#define XLAT 495
#define XLATB 496
#define XOR 497
#define XORB 498
#define XORL 499
#define XORW 500

 #endif /* _MNEMONICS_DEF_H */

